/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.audinate.gui.dnd.DevicePresetsTransferable
 *  com.audinate.gui.dnd.IDevicePresetsSink
 *  com.audinate.gui.dnd.IDevicePresetsSource
 *  com.audinate.presets.DevicePreset
 *  com.audinate.util.Log
 */
package com.audinate.gui.dnd;

import com.audinate.gui.dnd.DevicePresetsTransferable;
import com.audinate.gui.dnd.IDevicePresetsSink;
import com.audinate.gui.dnd.IDevicePresetsSource;
import com.audinate.presets.DevicePreset;
import com.audinate.util.Log;
import java.awt.GraphicsEnvironment;
import java.awt.Point;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.dnd.DragGestureEvent;
import java.awt.dnd.DragGestureListener;
import java.awt.dnd.DragGestureRecognizer;
import java.awt.dnd.DragSource;
import java.awt.dnd.DragSourceContext;
import java.awt.dnd.DragSourceDragEvent;
import java.awt.dnd.DragSourceDropEvent;
import java.awt.dnd.DragSourceEvent;
import java.awt.dnd.DragSourceListener;
import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;
import java.awt.image.BufferedImage;
import java.io.IOException;
import java.util.ArrayList;
import javax.swing.JComponent;
import javax.swing.TransferHandler;

public class DevicePresetsTransferHandler
extends TransferHandler {
    private static final long serialVersionUID = 1L;
    private Log mLog;
    private MyDragGestureRecognizer myRecognizer = null;

    public DevicePresetsTransferHandler() {
    }

    public DevicePresetsTransferHandler(Log log) {
        this.mLog = log;
    }

    @Override
    public int getSourceActions(JComponent jComponent) {
        return 1;
    }

    @Override
    protected Transferable createTransferable(JComponent jComponent) {
        if (jComponent instanceof IDevicePresetsSource) {
            IDevicePresetsSource iDevicePresetsSource = (IDevicePresetsSource)jComponent;
            Object[] objectArray = iDevicePresetsSource.getSelectedItems();
            if (objectArray == null || objectArray.length == 0) {
                return null;
            }
            ArrayList<DevicePreset> arrayList = new ArrayList<DevicePreset>();
            for (int i = 0; i < objectArray.length; ++i) {
                DevicePreset devicePreset = iDevicePresetsSource.getDevicePreset(objectArray[i]);
                if (devicePreset == null) continue;
                if (devicePreset instanceof ArrayList) {
                    ArrayList arrayList2 = (ArrayList)devicePreset;
                    arrayList.addAll(arrayList.size(), arrayList2);
                    continue;
                }
                arrayList.add(devicePreset);
            }
            if (arrayList != null && arrayList.size() > 0) {
                return new DevicePresetsTransferable(arrayList.toArray(new DevicePreset[arrayList.size()]));
            }
        }
        return null;
    }

    @Override
    public boolean canImport(JComponent jComponent, DataFlavor[] dataFlavorArray) {
        return jComponent instanceof IDevicePresetsSink;
    }

    @Override
    public boolean importData(JComponent jComponent, Transferable transferable) {
        DevicePreset[] devicePresetArray;
        try {
            devicePresetArray = (DevicePreset[])transferable.getTransferData(DevicePresetsTransferable.FLAVOR);
        }
        catch (IOException iOException) {
            if (this.mLog != null) {
                this.mLog.logThrowable(4, null, "DPTH.importData(): ", (Throwable)iOException);
            }
            return false;
        }
        catch (UnsupportedFlavorException unsupportedFlavorException) {
            if (this.mLog != null) {
                this.mLog.logThrowable(4, null, "DPTH.importData(): ", (Throwable)unsupportedFlavorException);
            }
            return false;
        }
        if (devicePresetArray == null) {
            if (this.mLog != null) {
                this.mLog.log(5, null, "DPTH.import data(): no transfer data");
            }
            return false;
        }
        if (jComponent instanceof IDevicePresetsSink) {
            IDevicePresetsSink iDevicePresetsSink = (IDevicePresetsSink)jComponent;
            return iDevicePresetsSink.putDevicePresets(devicePresetArray);
        }
        return false;
    }

    @Override
    public void exportAsDrag(JComponent jComponent, InputEvent inputEvent, int n) {
        int n2 = this.getSourceActions(jComponent);
        if (!(inputEvent instanceof MouseEvent) || n != 1 && n != 2 && n != 0x40000000 || (n2 & n) == 0) {
            n = 0;
        }
        if (n != 0 && !GraphicsEnvironment.isHeadless()) {
            if (this.myRecognizer == null) {
                this.myRecognizer = new MyDragGestureRecognizer(new MyDragHandler());
            }
            this.myRecognizer.gestured(jComponent, (MouseEvent)inputEvent, n2, n);
        } else {
            this.exportDone(jComponent, null, 0);
        }
    }

    private class MyDragGestureRecognizer
    extends DragGestureRecognizer {
        private static final long serialVersionUID = 1L;

        MyDragGestureRecognizer(DragGestureListener dragGestureListener) {
            super(DragSource.getDefaultDragSource(), null, 0, dragGestureListener);
        }

        @Override
        protected void registerListeners() {
        }

        @Override
        protected void unregisterListeners() {
        }

        void gestured(JComponent jComponent, MouseEvent mouseEvent, int n, int n2) {
            this.setComponent(jComponent);
            this.setSourceActions(n);
            this.appendEvent(mouseEvent);
            this.fireDragGestureRecognized(n2, mouseEvent.getPoint());
        }
    }

    private class MyDragHandler
    implements DragGestureListener,
    DragSourceListener {
        private boolean scrolls;

        private MyDragHandler() {
        }

        @Override
        public void dragDropEnd(DragSourceDropEvent dragSourceDropEvent) {
            DragSourceContext dragSourceContext = dragSourceDropEvent.getDragSourceContext();
            JComponent jComponent = (JComponent)dragSourceContext.getComponent();
            if (jComponent.getTransferHandler() instanceof DevicePresetsTransferHandler) {
                DevicePresetsTransferHandler devicePresetsTransferHandler = (DevicePresetsTransferHandler)jComponent.getTransferHandler();
                if (dragSourceDropEvent.getDropSuccess()) {
                    devicePresetsTransferHandler.exportDone(jComponent, dragSourceContext.getTransferable(), dragSourceDropEvent.getDropAction());
                } else {
                    devicePresetsTransferHandler.exportDone(jComponent, dragSourceContext.getTransferable(), 0);
                }
            }
            jComponent.setAutoscrolls(this.scrolls);
        }

        @Override
        public void dragEnter(DragSourceDragEvent dragSourceDragEvent) {
        }

        @Override
        public void dragExit(DragSourceEvent dragSourceEvent) {
        }

        @Override
        public void dragGestureRecognized(DragGestureEvent dragGestureEvent) {
            JComponent jComponent = (JComponent)dragGestureEvent.getComponent();
            if (jComponent.getTransferHandler() instanceof DevicePresetsTransferHandler) {
                DevicePresetsTransferHandler devicePresetsTransferHandler = (DevicePresetsTransferHandler)jComponent.getTransferHandler();
                Transferable transferable = devicePresetsTransferHandler.createTransferable(jComponent);
                if (transferable != null) {
                    this.scrolls = jComponent.getAutoscrolls();
                    jComponent.setAutoscrolls(false);
                    try {
                        BufferedImage bufferedImage = new BufferedImage(16, 16, 2);
                        dragGestureEvent.startDrag(null, bufferedImage, new Point(0, 0), transferable, this);
                    }
                    catch (RuntimeException runtimeException) {
                        jComponent.setAutoscrolls(this.scrolls);
                    }
                }
                devicePresetsTransferHandler.exportDone(jComponent, transferable, 0);
            }
        }

        @Override
        public void dragOver(DragSourceDragEvent dragSourceDragEvent) {
            dragSourceDragEvent.getDragSourceContext().setCursor(null);
        }

        @Override
        public void dropActionChanged(DragSourceDragEvent dragSourceDragEvent) {
        }
    }
}

